//------------------------------------------------------------------+
// Stochastic Momentum Index developed by William Blau              |
//                                              mladen              |
//+-----------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
//#property indicator_color4  Goldenrod
#property indicator_color5  Red
#property indicator_color6  LimeGreen
#property indicator_color7  DimGray
#property indicator_style7  STYLE_DOT
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3


#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision );
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision );
#import
//
//
//
//
//

//extern int  SMIPeriod1   = 13;
extern int  Smooth1                     = 6;
extern int  Smooth2                     = 8;
//extern int  SignalPeriod =  5;
extern double PaFilter                  = 1.0;
extern double PaCycles                  = 1.0;
extern int    DzLookBackBars            = 70;
extern double DzStartBuyProbability     = 0.10;
extern double DzStartSellProbability    = 0.10;
extern bool ColorOnSlope = true;

extern bool   alertsOn                  = false;
extern bool   alertsOnFiftyLine         = true;
extern bool   alertsOnUpperZone         = true;
extern bool   alertsOnLowerZone         = true;
extern bool   alertsOnOsOb              = true;
extern bool   alertsOnSlope             = true;
extern bool   alertsOnCurrent           = false;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = false;
extern bool   alertsNotification        = false;
extern bool   alertsEmail               = false;
//
//
//
//
//

double SMIBuffer[];
double SMIBufferDa[];
double SMIBufferDb[];
double SignalBuffer[];
double bl1[];
double sl1[];
double zli[];
double colors[];
double trends[][4];
#define _tmi  0
#define _tup1 1
#define _tup2 2
#define _tdn2 3

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,SMIBuffer);
   SetIndexBuffer(1,SMIBufferDa);
   SetIndexBuffer(2,SMIBufferDb);
   //SetIndexBuffer(3,SignalBuffer);
   SetIndexBuffer(4,bl1);
   SetIndexBuffer(5,sl1);
   SetIndexBuffer(6,zli);
   SetIndexBuffer(7,colors);
   IndicatorShortName("Dynamic Zones pa adaptive SMI ("+Smooth1+","+Smooth2+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
double wrkBuffer[][13];
double work[][4];
#define _ema00 0
#define _ema01 1
#define _ema10 2
#define _ema11 3

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
         if (colors[limit]==-1) CleanPoint(limit,SMIBufferDa,SMIBufferDb);

   //
   //
   //
   //
   // 
     // double alfaS = 2.0 / (1.0 + SignalPeriod);//
      double alfa1 = 2.0 / (1.0 + Smooth1);
      double alfa2 = 2.0 / (1.0 + Smooth2);

      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double Length = iHilbertPhase(wrkBuffer[r][12],PaFilter,PaCycles,i);
         double highest = High[iHighest(NULL,0,MODE_HIGH,Length,i)];//SMIPeriod1
         double lowest  = Low [iLowest (NULL,0,MODE_LOW ,Length,i)];//SMIPeriod1
         double sm      = Close[i]-(highest+lowest)*0.5;
         double hl      =           highest-lowest;

            work[r][_ema00] = work[r-1][_ema00]+alfa1*(sm             -work[r-1][_ema00]);
            work[r][_ema01] = work[r-1][_ema01]+alfa2*(work[r][_ema00]-work[r-1][_ema01]);
            work[r][_ema10] = work[r-1][_ema10]+alfa1*(hl             -work[r-1][_ema10]);
            work[r][_ema11] = work[r-1][_ema11]+alfa2*(work[r][_ema10]-work[r-1][_ema11]);
            if (work[r][_ema11] != 0)
                  SMIBuffer[i] = 100.00*(work[r][_ema01]/(0.5*work[r][_ema11]));
            else  SMIBuffer[i] = 0;
        //    SignalBuffer[i] = SignalBuffer[i+1] + alfaS*(SMIBuffer[i]-SignalBuffer[i+1]);
            
            //
            //
            //
            //
            //
            bl1[i]   = dzBuyP (SMIBuffer, DzStartBuyProbability,  DzLookBackBars, Bars, i,0.001);
            sl1[i]   = dzSellP(SMIBuffer, DzStartSellProbability, DzLookBackBars, Bars, i,0.001);
            zli[i]   = dzSellP(SMIBuffer, 0.5,                    DzLookBackBars, Bars, i,0.001);
            SMIBufferDa[i] = EMPTY_VALUE;
            SMIBufferDb[i] = EMPTY_VALUE;
            colors[i] = colors[i+1];
               if (ColorOnSlope)
               {
                  if (SMIBuffer[i]>SMIBuffer[i+1]) colors[i]= 1;
                  if (SMIBuffer[i]<SMIBuffer[i+1]) colors[i]=-1;
               }
               else
               {
                  if (SMIBuffer[i]>SignalBuffer[i+1]) colors[i]= 1;
                  if (SMIBuffer[i]<SignalBuffer[i+1]) colors[i]=-1;
               }
               if (colors[i] == -1) PlotPoint(i,SMIBufferDa,SMIBufferDb,SMIBuffer);
               setTrends(i,r);
      }
      manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
double workHil[][9];
#define _price      0
#define _smooth     1
#define _detrender  2
#define _period     3
#define _instPeriod 4
#define _phase      5
#define _deltaPhase 6
#define _Q1         7
#define _I1         8

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iHilbertPhase(double price, double filter, double cyclesToReach, int i, int s=0)
{
   if (ArrayRange(workHil,0)!=Bars) ArrayResize(workHil,Bars);
   int r = Bars-i-1; s = s*9;
      
   //
   //
   //
   //
   //
      
      workHil[r][s+_price]      = price;
      workHil[r][s+_smooth]     = (4.0*workHil[r][s+_price]+3.0*workHil[r-1][s+_price]+2.0*workHil[r-2][s+_price]+workHil[r-3][s+_price])/10.0;
      workHil[r][s+_detrender]  = calcComp(r,_smooth,s);
      workHil[r][s+_Q1]         = 0.15*calcComp(r,_detrender,s)  +0.85*workHil[r-1][s+_Q1];
      workHil[r][s+_I1]         = 0.15*workHil[r-3][s+_detrender]+0.85*workHil[r-1][s+_I1];
      workHil[r][s+_phase]      = workHil[r-1][s+_phase];
      workHil[r][s+_instPeriod] = workHil[r-1][s+_instPeriod];

      //
      //
      //
      //
      //
           
         if (MathAbs(workHil[r][s+_I1])>0)
                     workHil[r][s+_phase] = 180.0/Pi*MathArctan(MathAbs(workHil[r][s+_Q1]/workHil[r][s+_I1]));
           
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]>0) workHil[r][s+_phase] = 180-workHil[r][s+_phase];
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 180+workHil[r][s+_phase];
         if (workHil[r][s+_I1]>0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 360-workHil[r][s+_phase];

      //
      //
      //
      //
      //
                        
      workHil[r][s+_deltaPhase] = workHil[r-1][s+_phase]-workHil[r][s+_phase];

         if (workHil[r-1][s+_phase]<90 && workHil[r][s+_phase]>270)
             workHil[r][s+_deltaPhase] = 360+workHil[r-1][s+_phase]-workHil[r][s+_phase];
             workHil[r][s+_deltaPhase] = MathMax(MathMin(workHil[r][s+_deltaPhase],60),7);
      
            //
            //
            //
            //
            //
                  
            double alpha    = 2.0/(1.0+MathMax(filter,1));
            double phaseSum = 0; for (int k=0; phaseSum<cyclesToReach*360 && (r-k)>0; k++) phaseSum += workHil[r-k][s+_deltaPhase];
         
               if (k>0) workHil[r][s+_instPeriod]= k;
                  workHil[r][s+_period] = workHil[r-1][s+_period]+alpha*(workHil[r][s+_instPeriod]-workHil[r-1][s+_period]);
   return (workHil[r][s+_period]);
}

//
//
//
//
//

double calcComp(int r, int from, int s)
{
   return((0.0962*workHil[r  ][s+from] + 
           0.5769*workHil[r-2][s+from] - 
           0.5769*workHil[r-4][s+from] - 
           0.0962*workHil[r-6][s+from]) * (0.075*workHil[r-1][s+_period] + 0.54));
}

//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

///////////////////////////////////////////////////


void setTrends(int i, int r)
{
   trends[r][_tmi]  = trends[r-1][_tmi];
   trends[r][_tup1] = trends[r-1][_tup1];
   trends[r][_tup2] = trends[r-1][_tup2];
   trends[r][_tdn2] = trends[r-1][_tdn2];
   
      if (SMIBuffer[i] > zli[i])    trends[r][_tmi]  =  1;
      if (SMIBuffer[i] < zli[i])    trends[r][_tmi]  = -1;
      if (SMIBuffer[i] > sl1[i])    trends[r][_tup1] =  1;
      if (SMIBuffer[i] < sl1[i])    trends[r][_tup1] = -1;
      if (SMIBuffer[i] > bl1[i])    trends[r][_tup2] =  1;
      if (SMIBuffer[i] < bl1[i])    trends[r][_tup2] = -1;
      if (SMIBuffer[i] > SMIBuffer[i+1])  trends[r][_tdn2] =  1;
      if (SMIBuffer[i] < SMIBuffer[i+1])  trends[r][_tdn2] = -1;
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      //
      whichBar = Bars-whichBar-1;
      //
      //
      //

      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnFiftyLine && trends[whichBar][_tmi] != trends[whichBar-1][_tmi])
      {
         if (trends[whichBar][_tmi] ==  1) doAlert(time1,mess1,whichBar,"crossed fifty up");
         if (trends[whichBar][_tmi] == -1) doAlert(time1,mess1,whichBar,"crossed fifty down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnUpperZone && trends[whichBar][_tup1] != trends[whichBar-1][_tup1])
      {
         if (trends[whichBar][_tup1] ==  1) doAlert(time2,mess2,whichBar,"crossed Upper up");
         if (trends[whichBar][_tup1] == -1) doAlert(time2,mess2,whichBar,"crossed Upper down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnLowerZone && trends[whichBar][_tup2] != trends[whichBar-1][_tup2])
      {
         if (trends[whichBar][_tup2] ==  1) doAlert(time3,mess3,whichBar,"crossed Lower up");
         if (trends[whichBar][_tup2] == -1) doAlert(time3,mess3,whichBar,"crossed Lower down");
      }
      static datetime time5 = 0;
      static string   mess5 = "";
      if (alertsOnSlope && trends[whichBar][_tdn2] != trends[whichBar-1][_tdn2])
      {
         if (trends[whichBar][_tdn2] ==  1) doAlert(time5,mess5,whichBar,"sloping up");
         if (trends[whichBar][_tdn2] == -1) doAlert(time5,mess5,whichBar,"sloping down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Dz pa SMI ",doWhat);
          if (alertsMessage)      Alert(message);
          if (alertsNotification) SendNotification(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol()," Dz pa SMI "),message);
          if (alertsSound)        PlaySound("alert2.wav");
   }
}
